import { Interval } from '../../core/interfaces';
import { TBySeriesId, DataLoader, LoadedSeriesData } from '../interfaces';
export declare enum ActionType {
    DATA_REQUESTED = 1,
    DATA_RETURNED = 2,
    DATA_ERRORED = 3,
    SET_SERIES_IDS = 4,
    SET_DATA_LOADER = 5,
    SET_DATA_LOADER_DEBOUNCE_TIMEOUT = 6,
    SET_DATA_LOADER_CONTEXT = 7,
    SET_X_DOMAIN = 8,
    SET_OVERRIDE_X_DOMAIN = 9,
    SET_Y_DOMAINS = 10,
    SET_OVERRIDE_Y_DOMAINS = 11,
    SET_HOVER = 12,
    SET_OVERRIDE_HOVER = 13,
    SET_SELECTION = 14,
    SET_OVERRIDE_SELECTION = 15,
    SET_CHART_PHYSICAL_WIDTH = 16,
}
export interface Action<P> {
    type: ActionType;
    payload: P;
}
export declare const setSeriesIds: (payload: string[]) => Action<string[]>;
export declare const setDataLoader: (payload: DataLoader) => Action<DataLoader>;
export declare const setDataLoaderDebounceTimeout: (payload: number) => Action<number>;
export declare const setDataLoaderContext: (payload: any) => Action<any>;
export declare const setChartPhysicalWidth: (payload: number) => Action<number>;
export declare const setXDomain: (payload: Interval) => Action<Interval>;
export declare const setOverrideXDomain: (payload: Interval | undefined) => Action<Interval | undefined>;
export declare const setYDomains: (payload: TBySeriesId<Interval>) => Action<TBySeriesId<Interval>>;
export declare const setOverrideYDomains: (payload: TBySeriesId<Interval> | undefined) => Action<TBySeriesId<Interval> | undefined>;
export declare const setHover: (payload: number | undefined) => Action<number | undefined>;
export declare const setOverrideHover: (payload: number | "none" | undefined) => Action<number | "none" | undefined>;
export declare const setSelection: (payload: Interval | undefined) => Action<Interval | undefined>;
export declare const setOverrideSelection: (payload: "none" | Interval | undefined) => Action<"none" | Interval | undefined>;
export declare const dataRequested: (payload: string[]) => Action<string[]>;
export declare const dataReturned: (payload: TBySeriesId<LoadedSeriesData>) => Action<TBySeriesId<LoadedSeriesData>>;
export declare const dataErrored: (payload: TBySeriesId<any>) => Action<TBySeriesId<any>>;
