"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ActionType;
(function (ActionType) {
    ActionType[ActionType["DATA_REQUESTED"] = 1] = "DATA_REQUESTED";
    ActionType[ActionType["DATA_RETURNED"] = 2] = "DATA_RETURNED";
    ActionType[ActionType["DATA_ERRORED"] = 3] = "DATA_ERRORED";
    ActionType[ActionType["SET_SERIES_IDS"] = 4] = "SET_SERIES_IDS";
    ActionType[ActionType["SET_DATA_LOADER"] = 5] = "SET_DATA_LOADER";
    ActionType[ActionType["SET_DATA_LOADER_DEBOUNCE_TIMEOUT"] = 6] = "SET_DATA_LOADER_DEBOUNCE_TIMEOUT";
    ActionType[ActionType["SET_DATA_LOADER_CONTEXT"] = 7] = "SET_DATA_LOADER_CONTEXT";
    ActionType[ActionType["SET_X_DOMAIN"] = 8] = "SET_X_DOMAIN";
    ActionType[ActionType["SET_OVERRIDE_X_DOMAIN"] = 9] = "SET_OVERRIDE_X_DOMAIN";
    ActionType[ActionType["SET_Y_DOMAINS"] = 10] = "SET_Y_DOMAINS";
    ActionType[ActionType["SET_OVERRIDE_Y_DOMAINS"] = 11] = "SET_OVERRIDE_Y_DOMAINS";
    ActionType[ActionType["SET_HOVER"] = 12] = "SET_HOVER";
    ActionType[ActionType["SET_OVERRIDE_HOVER"] = 13] = "SET_OVERRIDE_HOVER";
    ActionType[ActionType["SET_SELECTION"] = 14] = "SET_SELECTION";
    ActionType[ActionType["SET_OVERRIDE_SELECTION"] = 15] = "SET_OVERRIDE_SELECTION";
    ActionType[ActionType["SET_CHART_PHYSICAL_WIDTH"] = 16] = "SET_CHART_PHYSICAL_WIDTH";
})(ActionType = exports.ActionType || (exports.ActionType = {}));
function createActionCreator(type) {
    return function (payload) {
        return { type: type, payload: payload };
    };
}
exports.setSeriesIds = createActionCreator(ActionType.SET_SERIES_IDS);
exports.setDataLoader = createActionCreator(ActionType.SET_DATA_LOADER);
exports.setDataLoaderDebounceTimeout = createActionCreator(ActionType.SET_DATA_LOADER_DEBOUNCE_TIMEOUT);
exports.setDataLoaderContext = createActionCreator(ActionType.SET_DATA_LOADER_CONTEXT);
exports.setChartPhysicalWidth = createActionCreator(ActionType.SET_CHART_PHYSICAL_WIDTH);
exports.setXDomain = createActionCreator(ActionType.SET_X_DOMAIN);
exports.setOverrideXDomain = createActionCreator(ActionType.SET_OVERRIDE_X_DOMAIN);
exports.setYDomains = createActionCreator(ActionType.SET_Y_DOMAINS);
exports.setOverrideYDomains = createActionCreator(ActionType.SET_OVERRIDE_Y_DOMAINS);
exports.setHover = createActionCreator(ActionType.SET_HOVER);
exports.setOverrideHover = createActionCreator(ActionType.SET_OVERRIDE_HOVER);
exports.setSelection = createActionCreator(ActionType.SET_SELECTION);
exports.setOverrideSelection = createActionCreator(ActionType.SET_OVERRIDE_SELECTION);
exports.dataRequested = createActionCreator(ActionType.DATA_REQUESTED);
exports.dataReturned = createActionCreator(ActionType.DATA_RETURNED);
exports.dataErrored = createActionCreator(ActionType.DATA_ERRORED);
//# sourceMappingURL=atomicActions.js.map