import { GenericStoreEnhancer, Middleware } from 'redux';
import { Interval, SeriesData } from '../core';
export declare type SeriesId = string;
export declare type ChartId = string;
export declare type TBySeriesId<T> = {
    [seriesId: string]: T;
};
export interface LoadedSeriesData {
    data: SeriesData;
    yDomain: Interval;
}
export declare type DataLoader = (seriesIds: SeriesId[], xDomain: Interval, chartPixelWidth: number, currentLoadedData: TBySeriesId<LoadedSeriesData>, context?: any) => TBySeriesId<Promise<LoadedSeriesData>>;
export interface DebugStoreHooks {
    middlewares?: Middleware[];
    enhancers?: GenericStoreEnhancer[];
}
