/// <reference types="react" />
import * as React from 'react';
import { Interval, BooleanMouseEventHandler } from '../../core';
import { setSelection, setHover } from '../flux/atomicActions';
import { setXDomainAndLoad } from '../flux/compoundActions';
export interface OwnProps {
    shouldZoom?: BooleanMouseEventHandler;
    shouldPan?: BooleanMouseEventHandler;
    shouldHover?: BooleanMouseEventHandler;
    shouldBrush?: BooleanMouseEventHandler;
    zoomSpeed?: number;
}
export interface ConnectedProps {
    xDomain: Interval;
}
export interface DispatchProps {
    setXDomainAndLoad: typeof setXDomainAndLoad;
    setSelection: typeof setSelection;
    setHover: typeof setHover;
}
export declare class ConnectedInteractionCaptureLayer extends React.PureComponent<OwnProps & ConnectedProps & DispatchProps, {}> {
    render(): JSX.Element;
    private _zoom;
    private _pan;
    private _brush;
    private _hover;
}
declare var _default: React.ComponentClass<OwnProps>;
export default _default;
