"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var redux_1 = require("redux");
var react_redux_1 = require("react-redux");
var core_1 = require("../../core");
var atomicActions_1 = require("../flux/atomicActions");
var compoundActions_1 = require("../flux/compoundActions");
var selectors_1 = require("../model/selectors");
var ConnectedInteractionCaptureLayer = (function (_super) {
    __extends(ConnectedInteractionCaptureLayer, _super);
    function ConnectedInteractionCaptureLayer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._zoom = function (factor, anchorBias) {
            _this.props.setXDomainAndLoad(core_1.zoomInterval(_this.props.xDomain, factor, anchorBias));
        };
        _this._pan = function (logicalUnits) {
            _this.props.setXDomainAndLoad(core_1.panInterval(_this.props.xDomain, logicalUnits));
        };
        _this._brush = function (logicalUnitInterval) {
            _this.props.setSelection(logicalUnitInterval);
        };
        _this._hover = function (logicalPosition) {
            _this.props.setHover(logicalPosition);
        };
        return _this;
    }
    ConnectedInteractionCaptureLayer.prototype.render = function () {
        return (React.createElement(core_1.InteractionCaptureLayer, { xDomain: this.props.xDomain, onZoom: !!this.props.shouldZoom ? this._zoom : undefined, onPan: !!this.props.shouldPan ? this._pan : undefined, onHover: !!this.props.shouldHover ? this._hover : undefined, onBrush: !!this.props.shouldBrush ? this._brush : undefined, shouldZoom: this.props.shouldZoom, shouldPan: this.props.shouldPan, shouldHover: this.props.shouldHover, shouldBrush: this.props.shouldBrush, zoomSpeed: this.props.zoomSpeed }));
    };
    return ConnectedInteractionCaptureLayer;
}(React.PureComponent));
exports.ConnectedInteractionCaptureLayer = ConnectedInteractionCaptureLayer;
function mapStateToProps(state) {
    return {
        xDomain: selectors_1.selectXDomain(state)
    };
}
function mapDispatchToProps(dispatch) {
    return redux_1.bindActionCreators({
        setXDomainAndLoad: compoundActions_1.setXDomainAndLoad,
        setSelection: atomicActions_1.setSelection,
        setHover: atomicActions_1.setHover
    }, dispatch);
}
exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(ConnectedInteractionCaptureLayer);
//# sourceMappingURL=ConnectedInteractionCaptureLayer.js.map