"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var React = require("react");
var redux_1 = require("redux");
var react_redux_1 = require("react-redux");
var compoundActions_1 = require("../flux/compoundActions");
var ConnectedResizeSentinelLayer = (function (_super) {
    __extends(ConnectedResizeSentinelLayer, _super);
    function ConnectedResizeSentinelLayer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._maybeCallOnSizeChange = function () {
            var newWidth = _this.refs['element'].offsetWidth;
            if (_this.__lastWidth !== newWidth) {
                _this.__lastWidth = newWidth;
                _this.props.setChartPhysicalWidthAndLoad(_this.__lastWidth);
            }
        };
        return _this;
    }
    ConnectedResizeSentinelLayer.prototype.render = function () {
        return (React.createElement("div", { className: 'resize-sentinel', ref: 'element' }));
    };
    ConnectedResizeSentinelLayer.prototype.componentDidMount = function () {
        this._maybeCallOnSizeChange();
        this.__setSizeInterval = setInterval(this._maybeCallOnSizeChange, 1000);
    };
    ConnectedResizeSentinelLayer.prototype.componentWillUnmount = function () {
        clearInterval(this.__setSizeInterval);
    };
    ConnectedResizeSentinelLayer.prototype.componentWillReceiveProps = function (nextProps) {
        if (this.props.setChartPhysicalWidthAndLoad !== nextProps.setChartPhysicalWidthAndLoad && _.isNumber(this.__lastWidth)) {
            this.props.setChartPhysicalWidthAndLoad(this.__lastWidth);
        }
    };
    return ConnectedResizeSentinelLayer;
}(React.PureComponent));
function mapDispatchToProps(dispatch) {
    return redux_1.bindActionCreators({ setChartPhysicalWidthAndLoad: compoundActions_1.setChartPhysicalWidthAndLoad }, dispatch);
}
exports.default = react_redux_1.connect(undefined, mapDispatchToProps)(ConnectedResizeSentinelLayer);
//# sourceMappingURL=ConnectedResizeSentinelLayer.js.map