"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_redux_1 = require("react-redux");
var core_1 = require("../../core");
var selectors_1 = require("../model/selectors");
function mapStateToProps(state, ownProps) {
    if (state.seriesIds.indexOf(ownProps.seriesId) === -1) {
        throw new Error("Cannot render data for missing series ID " + ownProps.seriesId);
    }
    return {
        data: selectors_1.selectData(state)[ownProps.seriesId],
        xDomain: selectors_1.selectXDomain(state)
    };
}
exports.default = react_redux_1.connect(mapStateToProps)(core_1.SpanLayer);
//# sourceMappingURL=ConnectedSpanLayer.js.map