"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
function chainLoaders() {
    var loaders = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        loaders[_i] = arguments[_i];
    }
    var chainedLoader = function (seriesIds, xDomain, chartPixelWidth, currentLoadedData, context) {
        var accumulator = {};
        var seriesIdsToLoad = seriesIds;
        loaders.forEach(function (loader) {
            var loadedSeries = loader(seriesIdsToLoad, xDomain, chartPixelWidth, currentLoadedData, context);
            seriesIdsToLoad = seriesIdsToLoad.filter(function (id) { return !loadedSeries[id]; });
            _.assign(accumulator, loadedSeries);
        });
        var rejectedIds = _.fromPairs(seriesIdsToLoad.map(function (seriesId) { return [
            seriesId,
            Promise.reject(new Error("No loader specified that can handle series ID '" + seriesId + "'"))
        ]; }));
        return _.assign({}, accumulator, rejectedIds);
    };
    return chainedLoader;
}
exports.chainLoaders = chainLoaders;
//# sourceMappingURL=loaderUtils.js.map