"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var reselect_1 = require("reselect");
function createSubSelector(selectParentState, fieldName) {
    return reselect_1.createSelector(selectParentState, function (state) { return state[fieldName]; });
}
var selectLoadedSeriesData = function (state) { return state.loadedDataBySeriesId; };
var selectUiStateInternal = function (state) { return state.uiState; };
var selectUiStateOverride = function (state) { return state.uiStateConsumerOverrides; };
exports.selectLoadedYDomains = reselect_1.createSelector(selectLoadedSeriesData, function (loadedSeriesData) { return _.mapValues(loadedSeriesData, function (loadedSeriesData) { return loadedSeriesData.yDomain; }); });
exports.selectData = reselect_1.createSelector(selectLoadedSeriesData, function (loadedSeriesData) { return _.mapValues(loadedSeriesData, function (loadedSeriesData) { return loadedSeriesData.data; }); });
exports.selectXDomain = reselect_1.createSelector(createSubSelector(selectUiStateInternal, 'xDomain'), createSubSelector(selectUiStateOverride, 'xDomain'), function (internal, override) { return override || internal; });
exports.selectYDomains = reselect_1.createSelector(exports.selectLoadedYDomains, createSubSelector(selectUiStateInternal, 'yDomainBySeriesId'), createSubSelector(selectUiStateOverride, 'yDomainBySeriesId'), function (loaded, internal, override) { return _.assign({}, loaded, internal, override); });
exports.selectHover = reselect_1.createSelector(createSubSelector(selectUiStateInternal, 'hover'), createSubSelector(selectUiStateOverride, 'hover'), function (internal, override) {
    if (override != null) {
        return override === 'none' ? undefined : override;
    }
    else {
        return internal;
    }
});
exports.selectSelection = reselect_1.createSelector(createSubSelector(selectUiStateInternal, 'selection'), createSubSelector(selectUiStateOverride, 'selection'), function (internal, override) {
    if (override != null) {
        return override === 'none' ? undefined : override;
    }
    else {
        return internal;
    }
});
//# sourceMappingURL=selectors.js.map