import { Interval } from '../../core';
import { SeriesId, TBySeriesId, DataLoader, LoadedSeriesData } from '../interfaces';
export interface DefaultChartState {
    xDomain?: Interval;
    yDomains?: TBySeriesId<Interval>;
}
export interface UiState {
    xDomain: Interval;
    yDomainBySeriesId: TBySeriesId<Interval>;
    hover?: number;
    selection?: Interval;
}
export interface OverriddenUiState {
    xDomain?: Interval;
    yDomainBySeriesId?: TBySeriesId<Interval>;
    hover?: number | 'none';
    selection?: Interval | 'none';
}
export interface ChartState {
    debounceTimeout: number;
    loaderContext?: any;
    physicalChartWidth: number;
    seriesIds: SeriesId[];
    loadedDataBySeriesId: TBySeriesId<LoadedSeriesData>;
    loadVersionBySeriesId: TBySeriesId<string>;
    errorBySeriesId: TBySeriesId<any>;
    dataLoader: DataLoader;
    uiState: UiState;
    uiStateConsumerOverrides: OverriddenUiState;
}
export declare const invalidLoader: DataLoader;
export declare const DEFAULT_CHART_STATE: ChartState;
