/// <reference types="react" />
import * as React from 'react';
export interface Props {
    className?: string;
    zoomSpeed?: number | ((e: React.WheelEvent<HTMLElement>) => number);
    onZoom?: (factor: number, xPct: number, yPct: number, e: React.WheelEvent<HTMLElement>) => void;
    onDragStart?: (xPct: number, yPct: number, e: React.MouseEvent<HTMLElement> | MouseEvent) => void;
    onDrag?: (xPct: number, yPct: number, e: React.MouseEvent<HTMLElement> | MouseEvent) => void;
    onDragEnd?: (xPct: number, yPct: number, e: React.MouseEvent<HTMLElement> | MouseEvent) => void;
    onClick?: (xPct: number, yPct: number, e: React.MouseEvent<HTMLElement>) => void;
    onHover?: (xPct: number | undefined, yPct: number | undefined, e: React.MouseEvent<HTMLElement>) => void;
    children?: React.ReactNode;
}
export interface State {
    mouseDownClientX?: number;
    mouseDownClientY?: number;
    lastMouseMoveClientX?: number;
    lastMouseMoveClientY?: number;
}
export default class MouseCapture extends React.PureComponent<Props, State> {
    static propTypes: React.ValidationMap<Props>;
    static defaultProps: Partial<Props>;
    private element;
    state: State;
    componentWillUnmount(): void;
    render(): JSX.Element;
    private _createPhysicalToLogicalScales();
    private _clearState();
    private _maybeDispatchDragHandler(e, handler?);
    private _addWindowMouseEventHandlers;
    private _removeWindowMouseEventHandlers;
    private _onMouseDownInCaptureArea;
    private _onMouseMoveInCaptureArea;
    private _onMouseUpInCaptureArea;
    private _onMouseMoveInWindow;
    private _onMouseUpInWindow;
    private _onMouseLeaveCaptureArea;
    private _onWheel;
}
