"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var d3Scale = require("d3-scale");
var propTypes_1 = require("../propTypes");
var renderUtils_1 = require("../renderUtils");
var XAxis = (function (_super) {
    __extends(XAxis, _super);
    function XAxis() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    XAxis.prototype.render = function () {
        var _this = this;
        var xScale = this.props.scale()
            .domain([this.props.xDomain.min, this.props.xDomain.max])
            .range([0, 100]);
        var _a = renderUtils_1.computeTicks(xScale, this.props.ticks, this.props.tickFormat), ticks = _a.ticks, format = _a.format;
        return (React.createElement("div", { className: 'x-axis', style: {
                color: this.props.color
            } }, ticks.map(function (tick, i) {
            return React.createElement("div", { className: 'tick', style: { left: "calc(" + xScale(tick) + "% + 1px)" }, key: i },
                React.createElement("span", { className: 'label', style: { borderColor: _this.props.color } }, format(tick)));
        })));
    };
    return XAxis;
}(React.PureComponent));
XAxis.propTypes = __assign({}, propTypes_1.default.axisSpecPartial, { xDomain: propTypes_1.default.interval.isRequired });
XAxis.defaultProps = {
    scale: d3Scale.scaleTime
};
exports.default = XAxis;
//# sourceMappingURL=XAxis.js.map