"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var d3Scale = require("d3-scale");
var propTypes_1 = require("../propTypes");
var componentUtils_1 = require("../componentUtils");
var renderUtils_1 = require("../renderUtils");
var YAxis = (function (_super) {
    __extends(YAxis, _super);
    function YAxis() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    YAxis.prototype.render = function () {
        var _this = this;
        var yScale = this.props.scale()
            .domain([this.props.yDomain.min, this.props.yDomain.max])
            .range([0, 100]);
        var _a = renderUtils_1.computeTicks(yScale, this.props.ticks, this.props.tickFormat), ticks = _a.ticks, format = _a.format;
        return (React.createElement("div", { className: 'y-axis', style: {
                color: this.props.color,
                borderRightColor: this.props.color
            } }, ticks.map(function (tick, i) {
            return React.createElement("div", { className: 'tick', style: { top: "calc(" + (100 - yScale(tick)) + "% - 0.5px)" }, key: i },
                React.createElement("span", { className: 'label' }, format(tick)),
                React.createElement("span", { className: 'mark', style: { borderBottomColor: _this.props.color } }));
        })));
    };
    return YAxis;
}(React.PureComponent));
YAxis.propTypes = __assign({}, propTypes_1.default.axisSpecPartial, { yDomain: propTypes_1.default.interval.isRequired });
YAxis.defaultProps = {
    scale: d3Scale.scaleLinear
};
exports.default = componentUtils_1.wrapWithAnimatedYDomain(YAxis);
//# sourceMappingURL=YAxis.js.map