"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_motion_1 = require("react-motion");
function springifyInterval(interval) {
    return {
        min: react_motion_1.spring(interval.min),
        max: react_motion_1.spring(interval.max)
    };
}
function wrapWithAnimatedYDomain(Component) {
    var AnimatedYDomainWrapper = (function (_super) {
        __extends(AnimatedYDomainWrapper, _super);
        function AnimatedYDomainWrapper() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AnimatedYDomainWrapper.prototype.render = function () {
            var _this = this;
            return (React.createElement(react_motion_1.Motion, { style: springifyInterval(this.props.yDomain) }, function (interpolatedYDomain) { return React.createElement(Component, __assign({}, _this.props, { yDomain: interpolatedYDomain })); }));
        };
        return AnimatedYDomainWrapper;
    }(React.PureComponent));
    return AnimatedYDomainWrapper;
}
exports.wrapWithAnimatedYDomain = wrapWithAnimatedYDomain;
//# sourceMappingURL=componentUtils.js.map