"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var React = require("react");
function PixelRatioContextProvider(component) {
    component.childContextTypes = _.defaults({
        pixelRatio: React.PropTypes.number
    }, component.childContextTypes);
    var prototype = component.prototype;
    var oldGetChildContext = prototype.getChildContext;
    prototype.getChildContext = function () {
        var oldContext = oldGetChildContext ? oldGetChildContext.call(this) : {};
        return _.defaults({ pixelRatio: this.props.pixelRatio || this.context.pixelRatio }, oldContext);
    };
}
exports.default = PixelRatioContextProvider;
//# sourceMappingURL=PixelRatioContextProvider.js.map