/// <reference types="react" />
import * as React from 'react';
export declare type Color = string;
export declare type ScaleFunction = Function;
export declare type SeriesData = any[];
export declare type Ticks = ((axisDomain: Interval) => number[] | number) | number[] | number;
export declare type TickFormat = ((value: number) => string) | string;
export declare type BooleanMouseEventHandler = (event: React.MouseEvent<HTMLElement>) => boolean;
export interface Interval {
    min: number;
    max: number;
}
export interface PointDatum {
    xValue: number;
    yValue: number;
}
export interface SpanDatum {
    minXValue: number;
    maxXValue: number;
}
export interface BarDatum {
    minXValue: number;
    maxXValue: number;
    yValue: number;
}
export interface BucketDatum {
    minXValue: number;
    maxXValue: number;
    minYValue: number;
    maxYValue: number;
    firstYValue: number;
    lastYValue: number;
}
export interface AxisSpec {
    scale?: ScaleFunction;
    ticks?: Ticks;
    tickFormat?: TickFormat;
    color?: Color;
}
export declare enum JoinType {
    DIRECT = 0,
    LEADING = 1,
    TRAILING = 2,
}
