"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var d3Scale = require("d3-scale");
var NonReactRender_1 = require("../decorators/NonReactRender");
var PixelRatioContext_1 = require("../decorators/PixelRatioContext");
var PollingResizingCanvasLayer_1 = require("./PollingResizingCanvasLayer");
var renderUtils_1 = require("../renderUtils");
var componentUtils_1 = require("../componentUtils");
var propTypes_1 = require("../propTypes");
var BarLayer = (function (_super) {
    __extends(BarLayer, _super);
    function BarLayer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.nonReactRender = function () {
            var _a = _this.refs['canvasLayer'].resetCanvas(), width = _a.width, height = _a.height, context = _a.context;
            _renderCanvas(_this.props, width, height, context);
        };
        return _this;
    }
    BarLayer.prototype.render = function () {
        return React.createElement(PollingResizingCanvasLayer_1.default, { ref: 'canvasLayer', onSizeChange: this.nonReactRender, pixelRatio: this.context.pixelRatio });
    };
    return BarLayer;
}(React.PureComponent));
BarLayer.propTypes = {
    data: React.PropTypes.arrayOf(propTypes_1.default.barDatum).isRequired,
    xDomain: propTypes_1.default.interval.isRequired,
    yDomain: propTypes_1.default.interval.isRequired,
    color: React.PropTypes.string
};
BarLayer.defaultProps = {
    color: 'rgba(0, 0, 0, 0.7)'
};
BarLayer = __decorate([
    NonReactRender_1.default,
    PixelRatioContext_1.default
], BarLayer);
// Export for testing.
function _renderCanvas(props, width, height, context) {
    var _a = renderUtils_1.getIndexBoundsForSpanData(props.data, props.xDomain, 'minXValue', 'maxXValue'), firstIndex = _a.firstIndex, lastIndex = _a.lastIndex;
    if (firstIndex === lastIndex) {
        return;
    }
    var xScale = d3Scale.scaleLinear()
        .domain([props.xDomain.min, props.xDomain.max])
        .rangeRound([0, width]);
    var yScale = d3Scale.scaleLinear()
        .domain([props.yDomain.min, props.yDomain.max])
        .rangeRound([0, height]);
    context.beginPath();
    for (var i = firstIndex; i < lastIndex; ++i) {
        var left = xScale(props.data[i].minXValue);
        var right = xScale(props.data[i].maxXValue);
        var top_1 = height - yScale(props.data[i].yValue);
        var bottom = height - yScale(0);
        context.rect(left, bottom, right - left, top_1 - bottom);
    }
    context.fillStyle = props.color;
    context.fill();
}
exports._renderCanvas = _renderCanvas;
exports.default = componentUtils_1.wrapWithAnimatedYDomain(BarLayer);
//# sourceMappingURL=BarLayer.js.map