/// <reference types="react" />
import * as React from 'react';
import { Interval, BooleanMouseEventHandler } from '../interfaces';
export declare const DEFAULT_SHOULD_ZOOM: BooleanMouseEventHandler;
export declare const DEFAULT_SHOULD_PAN: BooleanMouseEventHandler;
export declare const DEFAULT_SHOULD_BRUSH: BooleanMouseEventHandler;
export declare const DEFAULT_SHOULD_HOVER: BooleanMouseEventHandler;
export interface Props {
    xDomain: Interval;
    shouldZoom?: BooleanMouseEventHandler;
    shouldPan?: BooleanMouseEventHandler;
    shouldBrush?: BooleanMouseEventHandler;
    shouldHover?: BooleanMouseEventHandler;
    onZoom?: (factor: number, anchorBias: number) => void;
    onPan?: (logicalUnits: number) => void;
    onBrush?: (logicalUnitInterval?: Interval) => void;
    onHover?: (logicalPosition?: number) => void;
    zoomSpeed?: number;
}
export interface State {
    isPanning: boolean;
    isBrushing: boolean;
    lastPanXPct?: number;
    startBrushXPct?: number;
}
export default class InteractionCaptureLayer extends React.PureComponent<Props, State> {
    static propTypes: React.ValidationMap<Props>;
    static defaultProps: Partial<Props>;
    state: State;
    render(): JSX.Element;
    private _dispatchPanAndBrushEvents(xPct, _yPct, _e);
    private _xPctToDomain(xPct);
    private _onZoom;
    private _onDragStart;
    private _onDrag;
    private _onDragEnd;
    private _onClick;
    private _onHover;
}
