/// <reference types="react" />
import * as React from 'react';
export interface Props {
    onSizeChange: () => void;
    pixelRatio?: number;
}
export interface State {
    width: number;
    height: number;
}
export default class PollingResizingCanvasLayer extends React.PureComponent<Props, State> {
    private __setSizeInterval;
    static propTypes: React.ValidationMap<Props>;
    static defaultProps: Partial<Props>;
    state: {
        width: number;
        height: number;
    };
    render(): JSX.Element;
    getCanvasElement(): HTMLCanvasElement;
    getDimensions(): {
        width: number;
        height: number;
    };
    resetCanvas(): {
        width: number;
        height: number;
        context: CanvasRenderingContext2D;
    };
    componentDidUpdate(): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    private _setSizeFromDom();
}
