"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var PollingResizingCanvasLayer = (function (_super) {
    __extends(PollingResizingCanvasLayer, _super);
    function PollingResizingCanvasLayer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            width: 0,
            height: 0
        };
        return _this;
    }
    PollingResizingCanvasLayer.prototype.render = function () {
        return (React.createElement("canvas", { className: 'lc-polling-resizing-canvas-layer', ref: 'canvas', width: this.state.width * this.props.pixelRatio, height: this.state.height * this.props.pixelRatio }));
    };
    PollingResizingCanvasLayer.prototype.getCanvasElement = function () {
        return this.refs['canvas'];
    };
    PollingResizingCanvasLayer.prototype.getDimensions = function () {
        return {
            width: this.state.width,
            height: this.state.height
        };
    };
    PollingResizingCanvasLayer.prototype.resetCanvas = function () {
        var canvas = this.getCanvasElement();
        var _a = this.state, width = _a.width, height = _a.height;
        var context = canvas.getContext('2d');
        context.setTransform(1, 0, 0, 1, 0, 0); // Same as resetTransform, but actually part of the spec.
        context.scale(this.props.pixelRatio, this.props.pixelRatio);
        context.clearRect(0, 0, width, height);
        return { width: width, height: height, context: context };
    };
    PollingResizingCanvasLayer.prototype.componentDidUpdate = function () {
        this.props.onSizeChange();
    };
    PollingResizingCanvasLayer.prototype.componentDidMount = function () {
        this._setSizeFromDom();
        this.__setSizeInterval = setInterval(this._setSizeFromDom.bind(this), 1000);
    };
    PollingResizingCanvasLayer.prototype.componentWillUnmount = function () {
        clearInterval(this.__setSizeInterval);
    };
    PollingResizingCanvasLayer.prototype._setSizeFromDom = function () {
        var wrapper = this.refs['canvas'];
        this.setState({
            width: wrapper.offsetWidth,
            height: wrapper.offsetHeight
        });
    };
    return PollingResizingCanvasLayer;
}(React.PureComponent));
PollingResizingCanvasLayer.propTypes = {
    onSizeChange: React.PropTypes.func.isRequired,
    pixelRatio: React.PropTypes.number
};
PollingResizingCanvasLayer.defaultProps = {
    pixelRatio: 1
};
exports.default = PollingResizingCanvasLayer;
//# sourceMappingURL=PollingResizingCanvasLayer.js.map