"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
exports.interval = React.PropTypes.shape({
    min: React.PropTypes.number.isRequired,
    max: React.PropTypes.number.isRequired
});
exports.controlledInterval = React.PropTypes.oneOfType([
    exports.interval,
    React.PropTypes.oneOf(['none'])
]);
exports.controlledHover = React.PropTypes.oneOfType([
    React.PropTypes.number,
    React.PropTypes.oneOf(['none'])
]);
exports.pointDatum = React.PropTypes.shape({
    xValue: React.PropTypes.number.isRequired,
    yValue: React.PropTypes.number.isRequired
});
exports.barDatum = React.PropTypes.shape({
    minXValue: React.PropTypes.number.isRequired,
    maxXValue: React.PropTypes.number.isRequired,
    yValue: React.PropTypes.number.isRequired
});
exports.bucketDatum = React.PropTypes.shape({
    minXValue: React.PropTypes.number.isRequired,
    maxXValue: React.PropTypes.number.isRequired,
    minYValue: React.PropTypes.number.isRequired,
    maxYValue: React.PropTypes.number.isRequired,
    firstYValue: React.PropTypes.number.isRequired,
    lastYValue: React.PropTypes.number.isRequired
});
exports.spanDatum = React.PropTypes.shape({
    minXValue: React.PropTypes.number.isRequired,
    maxXValue: React.PropTypes.number.isRequired
});
exports.ticks = React.PropTypes.oneOfType([
    React.PropTypes.func,
    React.PropTypes.number,
    React.PropTypes.arrayOf(React.PropTypes.number)
]);
exports.tickFormat = React.PropTypes.oneOfType([
    React.PropTypes.func,
    React.PropTypes.string
]);
exports.axisSpecPartial = {
    scale: React.PropTypes.func,
    ticks: exports.ticks,
    tickFormat: exports.tickFormat,
    color: React.PropTypes.string
};
exports.defaultChartState = React.PropTypes.shape({
    xDomain: exports.interval,
    yDomains: React.PropTypes.objectOf(exports.interval)
});
exports.default = {
    interval: exports.interval,
    controlledInterval: exports.controlledInterval,
    controlledHover: exports.controlledHover,
    pointDatum: exports.pointDatum,
    barDatum: exports.barDatum,
    bucketDatum: exports.bucketDatum,
    spanDatum: exports.spanDatum,
    ticks: exports.ticks,
    tickFormat: exports.tickFormat,
    axisSpecPartial: exports.axisSpecPartial,
    defaultChartState: exports.defaultChartState
};
//# sourceMappingURL=propTypes.js.map