import { Interval, Ticks, TickFormat } from './interfaces';
export interface IndexBounds {
    firstIndex: number;
    lastIndex: number;
}
export declare type ValueAccessor<T> = string | ((value: T) => number);
export declare function getIndexBoundsForPointData<T>(data: T[], xValueBounds: Interval, xValueAccessor: ValueAccessor<T>): IndexBounds;
export declare function getIndexBoundsForSpanData<T>(data: T[], xValueBounds: Interval, minXValueAccessor: ValueAccessor<T>, maxXValueAccessor: ValueAccessor<T>): IndexBounds;
export declare function computeTicks(scale: any, ticks?: Ticks, tickFormat?: TickFormat): {
    ticks: number[];
    format: Function;
};
