"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// From Typescript's lib.d.ts as of be2ca35b004f2079464fdca454c08a5019020260.
var PROPERTY_NAMES = [
    'fillStyle',
    'font',
    'globalAlpha',
    'globalCompositeOperation',
    'lineCap',
    'lineDashOffset',
    'lineJoin',
    'lineWidth',
    'miterLimit',
    'msFillRule',
    'msImageSmoothingEnabled',
    'shadowBlur',
    'shadowColor',
    'shadowOffsetX',
    'shadowOffsetY',
    'strokeStyle',
    'textAlign',
    'textBaseline',
    'mozImageSmoothingEnabled',
    'webkitImageSmoothingEnabled',
    'oImageSmoothingEnabled'
];
var METHOD_NAMES = [
    'arc',
    'arcTo',
    'beginPath',
    'bezierCurveTo',
    'clearRect',
    'clip',
    'closePath',
    'createImageData',
    'createLinearGradient',
    'createPattern',
    'createRadialGradient',
    'drawImage',
    'ellipse',
    'fill',
    'fillRect',
    'fillText',
    'getImageData',
    'getLineDash',
    'isPointInPath',
    'lineTo',
    'measureText',
    'moveTo',
    'putImageData',
    'quadraticCurveTo',
    'rect',
    'restore',
    'rotate',
    'save',
    'scale',
    'setLineDash',
    'setTransform',
    'stroke',
    'strokeRect',
    'strokeText',
    'transform',
    'translate'
];
var CanvasContextSpyExtensions = (function () {
    function CanvasContextSpyExtensions() {
        this.operations = [];
        this.calls = [];
        this.properties = [];
    }
    CanvasContextSpyExtensions.prototype.callsOmit = function () {
        var methodNames = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            methodNames[_i] = arguments[_i];
        }
        return this.calls.filter(function (call) { return methodNames.indexOf(call.method) === -1; });
    };
    CanvasContextSpyExtensions.prototype.callsOnly = function () {
        var methodNames = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            methodNames[_i] = arguments[_i];
        }
        return this.calls.filter(function (call) { return methodNames.indexOf(call.method) !== -1; });
    };
    return CanvasContextSpyExtensions;
}());
exports.CanvasContextSpyExtensions = CanvasContextSpyExtensions;
PROPERTY_NAMES.forEach(function (property) {
    Object.defineProperty(CanvasContextSpyExtensions.prototype, property, {
        set: function (value) {
            var propertySet = { property: property, value: value };
            this.properties.push(propertySet);
            this.operations.push(propertySet);
        }
    });
});
METHOD_NAMES.forEach(function (method) {
    CanvasContextSpyExtensions.prototype[method] = function () {
        var call = { method: method, arguments: Array.prototype.slice.apply(arguments) };
        this.calls.push(call);
        this.operations.push(call);
    };
});
exports.default = CanvasContextSpyExtensions;
//# sourceMappingURL=CanvasContextSpy.js.map